<template>
  <table class="m-character-information__table">
    <tbody>
      <tr v-for="item in statsInfoList" :key="item.key">
        <td class="m-character-information__label">{{ item.label }}</td>
        <td class="m-character-information__value" :ref="`stats-${item.key}`">
          {{ item.value }}{{ item.prefix }}
        </td>
      </tr>
    </tbody>
  </table>
</template>

<script>
import MPV from "../../../../murr_game/engine/murren_player_variables.json";

export default {
  name: "MCharacterStatsInformation",
  props: {
    stats: {
      type: Object,
      required: true,
    },
    immutableStats: {
      type: Object,
      required: true,
    },
  },
  computed: {
    statsInfoList() {
      return [
        {
          key: "hp",
          label: "Здоровье",
          value: this.hp,
          prefix: "",
        },
        {
          key: "maxDamage",
          label: "Урон",
          value: `${this.minDamage}-${this.maxDamage}`,
          prefix: "",
        },
        {
          key: "armor",
          label: "Броня",
          value: this.armor,
          prefix: "",
        },
        {
          key: "speed",
          label: "Скорость",
          value: this.speed,
          prefix: "",
        },
        {
          key: "evasion",
          label: "Меткость",
          value: this.evasion,
          prefix: "%",
        },
        {
          key: "criticalDamage",
          label: "Крит. урон",
          value: this.criticalDamage,
          prefix: "%",
        },
        {
          key: "criticalChance",
          label: "Крит. шанс",
          value: this.criticalChance,
          prefix: "%",
        },
      ];
    },
    speed() {
      return this.stats.intelligence;
    },
    minDamage() {
      return Math.round(
        this.maxDamage -
          (this.maxDamage / 100) * MPV.MAX_PHYSICAL_DAMAGE_MULTIPLY
      );
    },
    maxDamage() {
      return Math.round(
        MPV.MIN_PHYSICAL_DAMAGE +
          this.stats.strength / MPV.PHYSICAL_DAMAGE_MULTIPLY
      );
    },
    criticalDamage() {
      return (
        MPV.CRITICAL_DAMAGE +
        Math.ceil(this.stats.strength / MPV.CRITICAL_DAMAGE_MULTIPLY) * 10
      );
    },
    criticalChance() {
      return (
        MPV.CRITICAL_CHANCE +
        Math.ceil(this.stats.dexterity / MPV.CRITICAL_CHANCE_MULTIPLY)
      );
    },
    evasion() {
      const x =
        MPV.BASE_EVASION +
        Math.ceil(this.stats.dexterity / MPV.EVASION_MULTIPLY) *
          MPV.EVASION_INCREASE;
      return x <= 95 ? x : 95;
    },
    hp() {
      return MPV.BASE_HP + this.stats.vitality * MPV.VITALITY_HP_MULTIPLY;
    },
    armor() {
      return (
        MPV.ARMOR +
        Math.ceil(
          (this.stats.vitality / MPV.ARMOR_MULTIPLY) * MPV.ARMOR_INCREASE
        )
      );
    },
  },
  methods: {
    visualChangeState(newStats, oldStats) {
      const diffStats = newStats.filter((newStat) => {
        const oldStat = oldStats.find((os) => os.key === newStat.key);
        return newStat.value !== oldStat.value;
      });

      for (let stat of diffStats) {
        let $element = this.$refs[`stats-${stat.key}`][0];
        $element.classList.remove("change");
        $element.classList.add("change");

        setTimeout(() => {
          $element.classList.remove("change");
        }, 750);
      }
    },
  },
  watch: {
    statsInfoList(newStats, oldStats) {
      this.visualChangeState(newStats, oldStats);
    },

    statsVitalityList(newStats, oldStats) {
      this.visualChangeState(newStats, oldStats);
    },
  },
};
</script>
